---
title: DataTransfer.mozSetDataAt()
slug: Web/API/DataTransfer/mozSetDataAt
tags:
  - API
  - Method
  - Non-standard
  - Reference
  - drag and drop
---
<div>{{APIRef("HTML Drag and Drop API")}}</div>

<p>{{ Non-standard_header() }}{{deprecated_header}}</p>

<p>The <strong><code>DataTransfer.mozSetDataAt()</code></strong> method is used to add data to a specific index in the drag event's {{domxref("DataTransfer","data transfer")}} object.</p>

<p>A data transfer may store multiple items, each at a given zero-based index. <code>mozSetDataAt()</code> may only be called with an index argument less than {{domxref("DataTransfer.mozItemCount","mozItemCount")}} in which case an existing item is modified, or equal to {{domxref("DataTransfer.mozItemCount","mozItemCount")}} in which case a new item is added, and the {{domxref("DataTransfer.mozItemCount","mozItemCount")}} is incremented by one.</p>

<p>Data should be added in order of preference, with the most specific format added first and the least specific format added last. If data of the given format already exists, it is replaced in the same position as the old data.</p>

<p>The data should be either a {{domxref("DOMString","string")}}, a {{jsxref("Boolean")}} or number type (which will be converted into a string) or an {{ interface("nsISupports") }}.</p>

<div class="note"><strong>Note:</strong> This method is Gecko-specific.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <em>dataTransfer</em>.mozSetDataAt([type], data, index);
</pre>

<h3 id="Arguments">Arguments</h3>

<dl>
 <dt><em>type</em></dt>
 <dd>A {{domxref("DOMString","string")}} representing the type of the drag data to add to the {{domxref("DataTransfer","drag data object")}}.</dd>
 <dt><em>data</em></dt>
 <dd>A {{ interface("nsIVariant") }} representing the data to add to the {{domxref("DataTransfer","drag data object")}}.</dd>
 <dt><em>index</em></dt>
 <dd>A <code>unsigned long</code> representing the index of the data to add.</dd>
</dl>

<h3 id="Return_Value">Return value</h3>

<dl>
 <dt>void</dt>
 <dd></dd>
</dl>

<h2 id="Example">Example</h2>

<p>This example shows the use of the <code>mozSetDataAt()</code> method in a {{event("dragstart")}} handler.</p>

<pre class="brush: js">function dragstart_handler(event)
{
  var dt = event.dataTransfer;
  var idx = dt.mozItemCount;
  // Add two new items to the drag transfer
  if (idx &gt;= 0) {
    dt.mozSetDataAt("text/uri-list","http://www.example.com/", idx);
    dt.mozSetDataAt("text/html", "Hello <strong>World</strong>", idx+1);
  }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<p>This method is not defined in any Web standard.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DataTransfer.mozSetDataAt")}}</p>

<h2 id="See_also">See also</h2>

<p><a> </a></p>
